package com.sanei.libs.sample;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Calendar;

import android.app.Activity;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import com.sanei.libs.printersdk.PrinterSDK;

public class demo extends Activity {
	static Calendar calendar = Calendar.getInstance();
	static BluetoothAdapter btAdapter = null;
	static BluetoothDevice device = null;
	static BluetoothSocket socket = null;
	static OutputStream output = null;
	static InputStream input = null;
	static Intent serverIntent = null;
	static String address = null;
	static int printer_type = 0;
	// ビット反転テーブル
	static int[] bit_reverse = {
		0x00,0x80,0x40,0xc0,0x20,0xa0,0x60,0xe0,0x10,0x90,0x50,0xd0,0x30,0xb0,0x70,0xf0,
		0x08,0x88,0x48,0xc8,0x28,0xa8,0x68,0xe8,0x18,0x98,0x58,0xd8,0x38,0xb8,0x70,0xf8,
		0x04,0x84,0x44,0xc4,0x24,0xa4,0x64,0xe4,0x14,0x94,0x54,0xd4,0x34,0xb4,0x74,0xf4,
		0x0c,0x8c,0x4c,0xcc,0x2c,0xac,0x6c,0xec,0x1c,0x9c,0x5c,0xdc,0x3c,0xbc,0x7c,0xfc,
		0x02,0x82,0x42,0xc2,0x22,0xa2,0x62,0xe2,0x12,0x92,0x52,0xd2,0x32,0xb2,0x72,0xf2,
		0x0a,0x8a,0x4a,0xca,0x2a,0xaa,0x6a,0xea,0x1a,0x9a,0x5a,0xda,0x3a,0xba,0x7a,0xfa,
		0x06,0x86,0x46,0xc6,0x26,0xa6,0x66,0xe6,0x16,0x96,0x56,0xd6,0x36,0xb6,0x76,0xf6,
		0x0e,0x8e,0x4e,0xce,0x2e,0xae,0x6e,0xee,0x1e,0x9e,0x5e,0xde,0x3e,0xbe,0x7e,0xfe,
		0x01,0x81,0x41,0xc1,0x21,0xa1,0x61,0xe1,0x11,0x91,0x51,0xd1,0x31,0xb1,0x71,0xf1,
		0x09,0x89,0x49,0xc9,0x29,0xa9,0x69,0xe9,0x19,0x99,0x59,0xd9,0x39,0xb9,0x79,0xf9,
		0x05,0x85,0x45,0xc5,0x25,0xa5,0x65,0xe5,0x15,0x95,0x55,0xd5,0x35,0xb5,0x75,0xf5,
		0x0d,0x8d,0x4d,0xcd,0x2d,0xad,0x6d,0xed,0x1d,0x9d,0x5d,0xdd,0x3d,0xbd,0x7d,0xfd,
		0x03,0x83,0x43,0xc3,0x23,0xa3,0x63,0xe3,0x13,0x93,0x53,0xd3,0x33,0xb3,0x73,0xf3,
		0x0b,0x8b,0x4b,0xcb,0x2b,0xab,0x6b,0xeb,0x1b,0x9b,0x5b,0xdb,0x3b,0xbb,0x7b,0xfb,
		0x07,0x87,0x47,0xc7,0x27,0xa7,0x67,0xe7,0x17,0x97,0x57,0xd7,0x37,0xb7,0x77,0xf7,
		0x0f,0x8f,0x4f,0xcf,0x2f,0xaf,0x6f,0xef,0x1f,0x9f,0x5f,0xdf,0x3f,0xbf,0x7f,0xff,
	};
	//応答コマンド
	static byte[] res = {
		0x1b,0x76
	};

	//初期化コード
	static byte[] prn_demo_start = {
		//初期化
		0x1b,'@',
		//印字濃度設定（１２０％）
		0x1b,0x59,(byte)4,
	};
	//終了コード
	static byte[] prn_demo_last = {
		//初期化
		0x1b,'@',
	};
	static byte[] prn_qr_code = {
		//QRコードサンプルデータ
		0x1d,
		0x51,
		6,
		4,
		4,
		0x1b,
		0x00,
		'h','t','t','p',':','/','/','w','w','w','.','s','a','n','e','i','-',
		'e','l','e','c','.','c','o','.','j','p',
		0x1b,0x4a,0x78, // 紙送りコード
		0x0a,
	};
	// 圧縮構造のビットイメージ指定（非圧縮モード）
	static byte[] prn_bmp_c10 = {
		0x1b, 0x2a, 0x10,
	};
	// 印字および紙送り
	static byte[] prn_feed_24dot = {
		0x1b, 0x4a, 24,
	};
	// 印字および紙送り
	static byte[] prn_feed_4lines = {
		0x1b, 0x64, 4,
	};
	// 印字位置指定
	static byte[] prn_align_left = {
		0x1b,0x61,0x00,
	};
	static byte[] prn_align_centre = {
		0x1b,0x61,0x01,
	};
	static byte[] prn_align_right = {
		0x1b,0x61,0x02,
	};

	/**
	 * ビットマップ画像をバイトデータに変換する
	 * @param src      Bitmap
	 * @param format   Bitmap.CompressFormat
	 * @param quality   int
	 * @return         byte[]
	 */
	public static byte[] chngBmpToData(Bitmap src, Bitmap.CompressFormat format, int quality) {
	   ByteArrayOutputStream output = new ByteArrayOutputStream();
	   src.compress(format, quality, output);
	   return output.toByteArray();
	}


	public void bmp_out(String address,String SDInFile) {
		boolean sts;
		int printer;
		int prn_status;

		//ディレイタイム指定して受信の待ち時間を調整する
		sts = PrinterSDK.btConnect(address,500);
		if(sts == false) {
			//アラートの表示
			new AlertDialog.Builder(demo.this)
			.setTitle("error")
			.setMessage("コネクト出来ません。")
			.setNeutralButton("OK",null)
			.show();
			// TODO Auto-generated catch block
			return;
		}

		//プリンタタイプ取得
		printer = PrinterSDK.getPrinterType();
		//初期化コマンド送信
		PrinterSDK.initPrint();
		//プリンタステータスを取得
		prn_status = PrinterSDK.getStatus();
		if(prn_status == -1) {
			//アラートの表示
       		new AlertDialog.Builder(demo.this)
       		.setTitle("error")
       		.setMessage("プリンタステータスエラーです。")
       		.setNeutralButton("OK",null)
       		.show();
       		//入出力ストリーム、及びbluetoothを閉じる
		    PrinterSDK.btClose();
			// TODO Auto-generated catch block
       		return;
		}
		if((prn_status & 0x01) != 0) {
			//アラートの表示
       		new AlertDialog.Builder(demo.this)
       		.setTitle("error")
       		.setMessage("紙切れです。")
       		.setNeutralButton("OK",null)
       		.show();
       		//入出力ストリーム、及びbluetoothを閉じる
		    PrinterSDK.btClose();
			// TODO Auto-generated catch block
       		return;
		}
		if((prn_status & 0x02) != 0) {
			//アラートの表示
       		new AlertDialog.Builder(demo.this)
       		.setTitle("error")
       		.setMessage("温度エラーです。")
       		.setNeutralButton("OK",null)
       		.show();
       		//入出力ストリーム、及びbluetoothを閉じる
		    PrinterSDK.btClose();
			// TODO Auto-generated catch block
       		return;
		}

        /***** BMPファイルを印字 -TOP- *****/
		File inFile = new File(SDInFile);

        // データバッファ
		byte[] readBytes  = null;

        try {
        	FileInputStream fis = new FileInputStream(inFile);
        	readBytes = new byte[fis.available()];
        	fis.read(readBytes);
        	fis.close();
        }
        catch (IOException e) {
        		e.printStackTrace();
        		PrinterSDK.btClose();
        		return;
        }
        /*****/

        /*** BMP情報と印字に必要な変数 -TOP- ***/
        // ファイルのサイズ
        //int iSzFile = ((int)(readBytes[5]&0xff)<<24) + ((int)(readBytes[4]&0xff)<<16) + ((int)(readBytes[3]&0xff)<<8) + (int)(readBytes[2]&0xff);
        int iBzOffset = ((int)(readBytes[13]&0xff)<<24) + ((int)(readBytes[12]&0xff)<<16) + ((int)(readBytes[11]&0xff)<<8) + (int)(readBytes[10]&0xff);

        // 読み込んだBMPデータの横方向、縦方向のピクセル数とバイト数を取得
        int iSzPxX = ((int)(readBytes[21]&0xff)<<24) + ((int)(readBytes[20]&0xff)<<16) + ((int)(readBytes[19]&0xff)<<8) + (int)(readBytes[18]&0xff);
        int iSzImgX = iSzPxX / 8;
        int iSzPxY = ((int)(readBytes[25]&0xff)<<24) + ((int)(readBytes[24]&0xff)<<16) + ((int)(readBytes[23]&0xff)<<8) + (int)(readBytes[22]&0xff);
        int iSzImgY = iSzPxY;
        byte[] cmd_width = new byte[1];
        // BMPデータの横方向のLONG数とバイト数
        int iSzLngX = (int)(Math.ceil( (double)(iSzPxX) / 32.0));
        int iSzLngXByt=iSzLngX*4;
        // BMPデータに含まれるパディングのバイト数
        int iSzPad = 0;
        //if ( (iSzImgX%4)!=0 ) {
        //	iSzPad = 4 - (iSzImgX%4);
        //}
        if ( (iSzImgX%2)!=0 ) {
        	iSzPad = 2 - (iSzImgX%2);
        }
        // イメージの縦方向のライン数、最後の分割画像の画像部分のライン数を算出。
        // 分割画像のサイズ = 24ライン * （印字可能な最大の横方向のバイト数、または画像の横幅のバイト数）
        // 分割画像の単位で送信データを構成する。
        int iImgLine, iImgLastLine;
        if (iSzPxY < 24) {
        	iImgLine = iSzImgY;
        }
        else {
        	iImgLine = 24;
        }
        if ( (iSzPxY%24)==0 ) {
        	iImgLastLine = 24;
        }
        else {
        	iImgLastLine = 24 - (iSzPxY % 24);
        }
        /*** BMP情報と印字に必要な変数 -END- ***/
	        /*** 印字用バッファ領域の生成 -TOP- ***/
        // 宣言
        byte[] bImgBuf = null;
        // Y方向の画面分割数
        int iImgDiv = (int)(Math.ceil((double)(iSzImgY) / 24.0));
        // 実体の生成
        int iMaxWidth;

        if(printer == 0) {
        	if (iSzPxX > 384) iMaxWidth = 48;	// SM1-21
        	else              iMaxWidth = iSzImgX;
        }
        else if(printer == 0) {
        	if (iSzPxX > 576) iMaxWidth = 72;	// BLM-80
        	else              iMaxWidth = iSzImgX;
        }
        else {
        	if (iSzPxX > 832) iMaxWidth = 104;	// SM2-41
        	else              iMaxWidth = iSzImgX;
        }

        cmd_width[0] = (byte)iMaxWidth;

        bImgBuf = new byte[iImgLine*iMaxWidth];
        /*** 印字用バッファ領域の生成 -END- ***/

        /*** 印字用バッファにBMPファイルから読み込んだデータを格納する -TOP- ***/
        // ループカウンタ、その他
       	int j, k, m, line, offset;
        int iCntD, iCntL, iCntW, iArrNum;
        k=iSzLngXByt-iSzPad;
        m=0;
        iArrNum=0;
        //縦方向ループ（画像全体）
        for (iCntD=0; iCntD<iImgDiv; iCntD++) {
        	// 縦方向ループ（24ライン単位）
        	for (iCntL=0; iCntL<iImgLine; iCntL++) {
        		line = (iSzPxY - ((iCntD * 24) + iCntL) - 1);
       			offset = iBzOffset + (line * iSzLngXByt);
        		// 横方向ループ（印字可能な最大の横方向のバイト数、または画像の横幅のバイト数）
        		for (iCntW=0; iCntW<iMaxWidth; iCntW++) {
        			j = offset + iCntW;
        			m = iCntL*iMaxWidth+iCntW;
        			// BMPに含まれる0x00パディングをスキップして、送信データを作る。
        			if (iCntW < k) {
        				//最終ブロック？
        				if ( iCntD==(iImgDiv-1) ){
        					//実データが無いライン
        					// 例えば、画像のサイズが768px*545pxの場合、必要な分割画面の数は23となり
        					// (545÷24=22余17)、最後の分割画面は17ライン分ほど画像データが不足する。
        					// 不足分は0x00(白)で埋めておく。
        					if ( iCntL>=(24-iImgLastLine) ) {
        						bImgBuf[m] = 0x00;
        					}
                            //実データがあるライン
        					else {
        						// １バイト毎にMSBとLSBを逆転する(コマンドリファレンスp22を参照)
        						// 例) 元データが"0xC5(= 11000101b)"であれば、"0xA3(= 10100011b)"に変換。
        						if (readBytes[j]<0) {
	        						iArrNum = readBytes[j] + 256;
	        					}
	        					else {
	        						iArrNum = readBytes[j];
	        					}
	        					bImgBuf[m] = (byte)bit_reverse[iArrNum];
        					}
        				}
        				//通常ライン
        				else {
        					if (readBytes[j]<0) {
        						iArrNum = readBytes[j] + 256;
        					}
        					else {
        						iArrNum = readBytes[j];
        					}
        					bImgBuf[m] = (byte)bit_reverse[iArrNum];
        				}
        			}
        		}
        	}
        	// BMPイメージの印字
	        //イメージコマンド送信
	        sts = PrinterSDK.sendData(prn_bmp_c10,prn_bmp_c10.length);
	        if(sts == false) {
	        	new AlertDialog.Builder(demo.this)
	  		    .setTitle("error")
	  		    .setMessage("書き込みエラーです。")
	  		    .setNeutralButton("OK",null)
	  		    .show();
	        	//入出力ストリーム、及びbluetoothを閉じる
			    PrinterSDK.btClose();
			    return;
	        }
	        //イメージコマンドの横バイト数を送信
	        sts = PrinterSDK.sendData(cmd_width,cmd_width.length);
	        if(sts == false) {
	  		    new AlertDialog.Builder(demo.this)
	  		    .setTitle("error")
	  		    .setMessage("書き込みエラーです。")
	  		    .setNeutralButton("OK",null)
	  		    .show();
	  		    //入出力ストリーム、及びbluetoothを閉じる
			    PrinterSDK.btClose();
			    return;
	        }
	        //イメージデータ送信
	        sts = PrinterSDK.sendData(bImgBuf,bImgBuf.length);
	        if(sts == false) {
	        	new AlertDialog.Builder(demo.this)
	  		    .setTitle("error")
	  		    .setMessage("書き込みエラーです。")
	  		    .setNeutralButton("OK",null)
	  		    .show();
	        	//入出力ストリーム、及びbluetoothを閉じる
			    PrinterSDK.btClose();
			    return;
	        }
	        // 印字ポインタを24ライン分送る
	        sts = PrinterSDK.sendData(prn_feed_24dot,prn_feed_24dot.length);
	        if(sts == false) {
	        	new AlertDialog.Builder(demo.this)
	  		    .setTitle("error")
	  		    .setMessage("書き込みエラーです。")
	  		    .setNeutralButton("OK",null)
	  		    .show();
	        	//入出力ストリーム、及びbluetoothを閉じる
			    PrinterSDK.btClose();
			    return;
	        }
			//ディレイでデータ転送量を調整する
			try {
				Thread.sleep(100);
			}
			catch (Exception exp){
			}
        }
        /*** 印字用バッファにBMPファイルから読み込んだデータを格納する -END- ***/
        /***** BMPファイルを印字 -END- *****/

		// 紙送り=4行
        sts = PrinterSDK.sendData(prn_feed_4lines,prn_feed_4lines.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
        }

        /***** QRコードの印刷 -TOP- *****/
		// 印字位置中央揃え
        sts = PrinterSDK.sendData(prn_align_centre,prn_align_centre.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
        }
		// QRコード"http://www.sanei-elec.co.jp"を印字
        sts = PrinterSDK.sendData(prn_qr_code,prn_qr_code.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
        }
		// 印字位置左揃え（デフォルトに戻す）
        sts = PrinterSDK.sendData(prn_align_left,prn_align_left.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
      }
        /***** QRコードの印刷 -END- *****/


		// 紙送り=4行
        sts = PrinterSDK.sendData(prn_feed_4lines,prn_feed_4lines.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
        }
		//デモ印字コード終了コード送信
        sts = PrinterSDK.sendData(prn_demo_last,prn_demo_last.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
        }
		//ステータス取得命令送信
        sts = PrinterSDK.sendData(res,res.length);
        if(sts == false) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("書き込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
        }

		byte[] data = new byte[16];
		int len=0;
		//ステータスを得る（ここで切断までの時間を調整）
		len = PrinterSDK.receiveData(data);
		if(len == -1) {
		      new AlertDialog.Builder(demo.this)
		      .setTitle("error")
		      .setMessage("読み込みエラーです。")
		      .setNeutralButton("OK",null)
		      .show();
		      //入出力ストリーム、及びbluetoothを閉じる
		      PrinterSDK.btClose();
		      return;
		}
		//入出力ストリーム、及びbluetoothを閉じる
		PrinterSDK.btClose();
	}

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        //ボタンを取り出す
        Button b = (Button)findViewById(R.id.widget30);

        //リスナークラスを作って登録する
        ClickListener1 listener1 = new ClickListener1();
        b.setOnClickListener(listener1);

        //ボタンを取り出す
        b = (Button)findViewById(R.id.widget31);

        //リスナークラスを作って登録する
        ClickListener2 listener2 = new ClickListener2();
        b.setOnClickListener(listener2);

        //デフォルトアドレスセット
        address = "00:00:00:00:00:00";
        //EditTextを取り出す
        EditText editText = (EditText) findViewById(R.id.widget33);
        //フォーカスを合わせなくして入力不可とする
        editText.setFocusable(false);
        //EditTextにアドレスをセットする
        editText.setText(address);

        serverIntent=new Intent(this,com.sanei.libs.sample.devicelist.class);
    }

	@Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
     	if(resultCode == RESULT_OK) {
     		address = data.getStringExtra("device_address");
            //EditTextを取り出す
            EditText editText = (EditText) findViewById(R.id.widget33);
            //EditTextにアドレスをセットする
            editText.setText(address);
    	}
    }
    //ＯＫボタンの処理
    class ClickListener1 implements OnClickListener {
		public void onClick(View v) {
	        // SDカードのファイルパス＆名称の取得
	        String SDInFile = Environment.getExternalStorageDirectory().getPath() + "/sm1-ami20.bmp";

			// 文字列（レシートNo）を数値に変えて印刷ルーチンに渡す
	        bmp_out(address, SDInFile);
		}
    }

    //デバイス検索ボタンの処理
    class ClickListener2 implements OnClickListener {
		public void onClick(View v) {
			if(serverIntent != null) {
				startActivityForResult(serverIntent,1);
			}
			//Intent serverIntent=new Intent(demo,SANEI_DEMO.SAMPLE.devicelist.class);
            //startActivityForResult(serverIntent,RQ_CONNECT_DEVICE);
		}
	}
}
